<?php

//Create array of entitiy IDs
$digital_signage_selected_entities = array();

//Create array of dates
$digital_signage_dates = array();

//For each entity ID in the field collection item.
foreach ($data->_field_data['nid']['entity']->field_event_schedule['und'] as $digital_signage_selected_entity){
//Add the associated entity ID to the array
    $digital_signage_selected_entities[] = $digital_signage_selected_entity['value'];
}

//Load an array of entities based on the array of entity IDs
$digital_signage_dates_entities = entity_load('field_collection_item', $digital_signage_selected_entities);

//print_r($digital_signage_dates_entities);

//For each entity in the entity array
foreach ($digital_signage_dates_entities as $digital_signage_current_entity) {
//add the date to the array of dates.

//print_r($digital_signage_current_entity->field_event_date['und'][0]);

//Necessary timezone conversion.
    $digital_signage_time = new DateTime($digital_signage_current_entity->field_event_date['und'][0]['value'], new DateTimeZone($digital_signage_current_entity->field_event_date['und'][0]['timezone_db']));
    $digital_signage_time->setTimeZone(new DateTimeZone($digital_signage_current_entity->field_event_date['und'][0]['timezone']));
//echo  "<br/>";
//echo $digital_signage_time->getTimestamp() . "<br/>";
//echo strtotime($digital_signage_current_entity->field_event_date['und'][0]['value']) . "<br/>";

//Add event start date as a unix timestamp.
//echo $digital_signage_current_entity->field_event_date['und'][0]['value'] . "<br/>";
//$digital_signage_dates[] = strtotime($digital_signage_current_entity->field_event_date['und'][0]['value']);
    $digital_signage_dates[] = $digital_signage_time->getTimestamp();
}

// Sort unix timestamps
sort($digital_signage_dates);

$digital_signage_all_times = array();

//schedule array structure times, sequences, years, months, days
$digital_signage_schedule_array = array(array());

foreach($digital_signage_dates as $digital_signage_date){
    if (!in_array(date("g:ia", $digital_signage_date), $digital_signage_all_times)){
        $digital_signage_all_times[] = date("g:ia", $digital_signage_date);
    }
}

for ($time = 0; $time < sizeof($digital_signage_all_times); $time++){

    //Controller variables.
    $s = 0;
    $d = 0;

    $digital_signage_start_sequence = true;

    for ($digital_signage_date = 0; $digital_signage_date < sizeof($digital_signage_dates); $digital_signage_date++)
    {
        if($digital_signage_all_times[$time] == date("g:ia", $digital_signage_dates[$digital_signage_date]))
        {

//            echo "CURRENT INDEXES:  TIME: $time | SEQUENCE: $s | DAY: $d" . "<br/>";
//            echo "PROCESSING: " . date("F j, Y g:ia", $digital_signage_dates[$digital_signage_date]) . "<br/>";

            //if first of sequence, simply include it.
            if ($digital_signage_start_sequence)
            {
                $digital_signage_schedule_array[$time][$s][$d] = $digital_signage_dates[$digital_signage_date];
//                $digital_signage_schedule_array[$time][$s][$d] = date("F j, Y g:ia",$digital_signage_dates[$digital_signage_date]);
                $digital_signage_start_sequence = false;
                $d++;
//                echo "Start fired! <br />";
            }
            //check if date is plus one day
            elseif (date(strtotime("+1 day", $digital_signage_schedule_array[$time][$s][$d-1])) == $digital_signage_dates[$digital_signage_date]) //CONSIDER 'OR' STATEMENT FOR DUPLICATE DATE HANDLING TO ENSURE THAT DUPLICATE DATE AND TIME DOES NOT START A NEW SEQUENCE.
            {
                $digital_signage_schedule_array[$time][$s][$d] = $digital_signage_dates[$digital_signage_date];
//                $digital_signage_schedule_array[$time][$s][$d] = date("F j, Y g:ia",$digital_signage_dates[$digital_signage_date]);
                $d++;
//                echo "In sequence rule fired! <br />";
            }
            //otherwise reset the sequence.
            else
            {
                $d=0;
                $s++;
                $digital_signage_schedule_array[$time][$s][$d] = $digital_signage_dates[$digital_signage_date];
//                $digital_signage_schedule_array[$time][$s][$d] = date("F j, Y g:ia",$digital_signage_dates[$digital_signage_date]);
                $d++;
//                echo "Reset sequence fired! <br />";
            }

//            echo "NEW INDEXES:  TIME: $time | SEQUENCE: $s | DAY: $d" . "<br/><br/><br/>";
        }
    }
}

$digital_signage_summarized_date = "";

for ($t = 0; $t < sizeof($digital_signage_schedule_array); $t++)
{

//    $digital_signage_new_month = false;
//    $digital_signage_new_year = false;

    for ($s = 0; $s < sizeof($digital_signage_schedule_array[$t]); $s++)
    {
        //controller variables
        $digital_signage_first_date_index = min(array_keys($digital_signage_schedule_array[$t][$s]));
        $digital_signage_last_date_index = max(array_keys($digital_signage_schedule_array[$t][$s]));
        $digital_signage_start_month = true;

        //echo "FIRST IN SEQUENCE: " . date("F j, Y g:ia", $digital_signage_schedule_array[$t][$s][$digital_signage_first_date_index]) . "<br/>";
        //echo "LAST IN SEQUENCE: " . date("F j, Y g:ia", $digital_signage_schedule_array[$t][$s][$digital_signage_last_date_index]) . "<br/>";

        // Check for year change.
        if($s > 0)
        {
            $digital_signage_last_last_date_index = max(array_keys($digital_signage_schedule_array[$t][$s-1]));
            if (date("Y", $digital_signage_schedule_array[$t][$s][$digital_signage_first_date_index]) != date("Y", $digital_signage_schedule_array[$t][$s-1][$digital_signage_last_last_date_index]))
            {
                $digital_signage_summarized_date = $digital_signage_summarized_date . date(", Y", $digital_signage_schedule_array[$t][$s-1][$digital_signage_last_last_date_index]);
            }
        }

        // String dividing characters
        //check if any more sequences exist and choose either , - or &.
        if ($s > 0)
        {
            if ($s == max(array_keys($digital_signage_schedule_array[$t])))
            {
                $digital_signage_summarized_date = $digital_signage_summarized_date . " &amp; ";
            }
            elseif ($s != 0 && sizeof($digital_signage_schedule_array[$t]) > 1)
            {
                $digital_signage_summarized_date = $digital_signage_summarized_date . ", ";
            }
        }

        // Start Date Range
        if($s == 0)
        {
            $digital_signage_summarized_date = $digital_signage_summarized_date . date("F j", $digital_signage_schedule_array[$t][$s][$digital_signage_first_date_index]);
        }
        else
        {
            $digital_signage_last_last_date_index = max(array_keys($digital_signage_schedule_array[$t][$s-1]));

            if (date("n", $digital_signage_schedule_array[$t][$s][$digital_signage_first_date_index]) == date("n", $digital_signage_schedule_array[$t][$s-1][$digital_signage_last_last_date_index])
                && date("Y", $digital_signage_schedule_array[$t][$s][$digital_signage_first_date_index]) != date("Y", $digital_signage_schedule_array[$t][$s-1][$digital_signage_last_last_date_index]))
            {
                $digital_signage_summarized_date = $digital_signage_summarized_date . date("F j", $digital_signage_schedule_array[$t][$s][$digital_signage_first_date_index]);
            }
            elseif (date("n", $digital_signage_schedule_array[$t][$s][$digital_signage_first_date_index]) == date("n", $digital_signage_schedule_array[$t][$s-1][$digital_signage_last_last_date_index]))
            {
                $digital_signage_summarized_date = $digital_signage_summarized_date . date("j", $digital_signage_schedule_array[$t][$s][$digital_signage_first_date_index]);
            }

            else
            {
                $digital_signage_summarized_date = $digital_signage_summarized_date . date("F j", $digital_signage_schedule_array[$t][$s][$digital_signage_first_date_index]);
            }
        }

        // End Date Range
        //check if sequence is in the same year as previous
        if (date("Y", $digital_signage_schedule_array[$t][$s][$digital_signage_first_date_index]) != date("Y", $digital_signage_schedule_array[$t][$s][$digital_signage_last_date_index]))
        {
            $digital_signage_summarized_date = $digital_signage_summarized_date . ", " . date("Y - ", $digital_signage_schedule_array[$t][$s][$digital_signage_first_date_index]) . date("F ", $digital_signage_schedule_array[$t][$s][$digital_signage_last_date_index]);
        }
        elseif (date("n", $digital_signage_schedule_array[$t][$s][$digital_signage_first_date_index]) != date("n", $digital_signage_schedule_array[$t][$s][$digital_signage_last_date_index]))
        {
            $digital_signage_summarized_date = $digital_signage_summarized_date . date(" - F ", $digital_signage_schedule_array[$t][$s][$digital_signage_last_date_index]);
        }
        elseif (sizeof($digital_signage_schedule_array[$t][$s]) > 1)
        {
            $digital_signage_summarized_date = $digital_signage_summarized_date . " - ";
        }

        //include last date in sequence
        if (sizeof($digital_signage_schedule_array[$t][$s]) > 1){
            $digital_signage_summarized_date = $digital_signage_summarized_date . date("j", $digital_signage_schedule_array[$t][$s][$digital_signage_last_date_index]);
        }

    }
    $digital_signage_last_sequence_index = max(array_keys($digital_signage_schedule_array[$t]));
    $digital_signage_last_date_index = max(array_keys($digital_signage_schedule_array[$t][$digital_signage_last_sequence_index]));

    $digital_signage_summarized_date = $digital_signage_summarized_date . date(", Y g:ia", $digital_signage_schedule_array[$t][$digital_signage_last_sequence_index][$digital_signage_last_date_index]);

    if (sizeof($digital_signage_schedule_array) > 1 && $t < max(array_keys($digital_signage_schedule_array)))
    {
        $digital_signage_summarized_date = $digital_signage_summarized_date . "<br/>";
    }
}
echo $digital_signage_summarized_date
?>